//*******************************************************************************
/*
The following program generates the main window for gameplay. It takes the power 
and angle value from the user and passes on to the other function for the 
projectile motion.

Prepared by team 1, lab batch 13.

Members:
	1> Pravesh Agrawal
	2> Sachin R.
	3> D. Anirudh
	4> Attanti Manideep
	5> Venkatesh Amgoth
	
	
The integration of the individual segments prepared by members and addition of some
parts of codes has been done together by all members in the 3rd team meet.

*/
//*******************************************************************************
#include<iostream>
#include<ezwin.h>
#include "bitmap.h"
#include<assert.h>
#include<cassert>
#include "rect.h"
#include<time.h>
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"label.h"
#include<ctime>

using namespace std;
  //Defining the GAMEWINDOW
  /* It is actually a bit tough to get the exact dimensions of the window to be put so 
  that it can cover the whole screen this has actually been done by trial and error */
  
  
  SimpleWindow ptanks("POCKET TANKS",29.0,14.5,Position(0.0,0.0));


	//A function that will be called on mouse mouse click
	/*Every function that should have got the position of the mouse click had to be defined
	within this function as it was not possible to take the coordinates of the click out
	of the function */
         
        // Program segment written by: Sachin and Anirudh.
        	
	int mouse_click(const Position &p){
  
  
  		/* (x,y) declared here will store the coordinates of the click using GetXDistance
  		and GetYDistance command */ 
  		
  		float x, y;
  		int power,angle;
  
  		x=p.GetXDistance();
  		y=p.GetYDistance();
  		
  		
  		/***********************************DEBUGGING**************************************
  		    This is for giving out the x and y coordinate that will help in debugging
                    cout<<"x coordinate is "<<x<<"  "<<"y coordinate is "<<y<<endl;*/
            
            		
  		  /* In this game there is a power rectangle that has been defined below the given 
  		  below part of the code will is conditional and it colours the power rectangle till
  		  the point where mouse has been clicked and it will thenlabel the power below the 
  		  mouse click*/
  		  /* Here the rectangles inside the power rectangle have been been redefined
  		  each time the mouse is clicked this is to remove the old label and put a new one */ 
  		  
  		
        if(x<=6.8 && x>=2.8 && y<=12.0 && y>=11.4){
  	        power=(x-2.8)*25;
  	        ptanks.RenderRectangle(Position(2.8,11.2),Position(7.0,12.2),Blue,false);
  	        ptanks.RenderRectangle(Position(2.75,11.35),Position(6.85,12.05),White,false);
  	        ptanks.RenderRectangle(Position(2.8,11.4),Position(6.8,12.0),White,true);
  	        ptanks.RenderRectangle(Position(2.8,11.4),Position(x,12.0),Red,true);
  	        
  	          //Giving the labels
  	          
  	        char pow[10];
    	        sprintf(pow, "%d", power);  
    	        Label Item(ptanks,x,y, pow);
    	        Item.Draw();	
               }
          
           
        //The same principle as power has been used over here too
          
        if(x<=27.8 && x>=23.8 && y<=12.0 && y>=11.4){
  	        angle=(x-23.8)*45;
  	        ptanks.RenderRectangle(Position(23.8,11.2),Position(28.0,12.2),Blue,false);
  	        ptanks.RenderRectangle(Position(23.75,11.35),Position(27.85,12.05),White,false);
  	        ptanks.RenderRectangle(Position(23.8,11.4),Position(27.8,12.0),White,true);
            ptanks.RenderRectangle(Position(23.8,11.4),Position(x,12.0),Red,true);
            
              //Giving the label
              
            char ang[10];
    	    sprintf(ang, "%d", angle);  
    	    Label Item(ptanks,x,y, ang);
            Item.Draw();	
        }
          /*After the player is sure about the angle and power he will click on the FIRE 
          button in the game window the following part of the code handles that part of 
          the code when player clicks on the FIRE button*/
           
        if(x>=13 && x<=16 && y>=11.4 && y<=12.4){
        
          //calling function from Team 2 (projectile function).
          
        
        
        
        
        
        
        }
        
             
       return 1;
   }

int ApiMain(){


  string s1,s2;
  //entering the name of player 1
  cout<<"enter the name of player 1"<<endl;
  cin>>s1;   



  //entering the name of player 2
  cout<<"enter the name of player 2"<<endl;
  cin>>s2;


  
  //opening the window
  ptanks.Open(); 
  
        /* setting the whole background of th‌e window to black for which on the whole window
        a black rectangle has been built */
        ptanks.RenderRectangle(Position(0.0,0.0),Position(29.0,14.5),Black);
        
        //defining the line that separates the window into two parts(terrain and input parts)
         
         //RANDOM FUNCTION FOR GENERATING  THE TERRAIN
         // Program segment written by: Pravesh Agrawal
         /*
         In this, two straight lines have been taken at some distance from one another as a hill
         and then random points are chosen between the lines and joined by lines.
         The lengh has been divided into 1000 parts and the y coordinate is stored in yter[].
         */   
         
         float len =29.0,yter[1000];
         srand(time(NULL));
         for(int i=0; i<1000; i++)
	 {
 		if(i<500)
                     yter[i]= 11 - (float)(rand()%100)/100 - (float)i*6/500;
 		else
    	             yter[i]= 11 - (float)(rand()%100)/100 - (float)(1000-i)*6/500;


		// This is for making the terrain and colouring it by making multiple broad vertical lines.
 		if(i>0)
    		    ptanks.RenderLine(Position(len*(i-1)/1000, yter[i-1]), Position(len*i/1000, yter[i]), Green, 0.0);
   
  		    ptanks.RenderLine(Position(len*i/1000,yter[i]), Position(len*i/1000, 11), Green, 0.8);
 	 }

	ptanks.RenderRectangle(Position(0.5,0.3),Position(6.5,2.3),Red,true);

        ptanks.RenderLine(Position(0.0,11.0),Position(40.0,11.0),Black,0.0);
    
         
         
        // The following code segment is written by: Manideep and Venkatesh.
        //Name of the player 1 and the scoreboard
        //Rendering the rectangle for displaying the names
    
    	ptanks.RenderRectangle(Position(0.7,0.5),Position(6.3,2.1),White,false);
    
            //writing "Player 1"
            ptanks.RenderText(Position(0.5,0.3),Position(3.5,1.3),"PLAYER 1 :",Blue);
            
      	    //giving the name of the player
      	    ptanks.RenderText(Position(1.5,0.3),Position(6.5,1.3),s1,Black);
      	    
            //labeling the scoreboard
            ptanks.RenderText(Position(0.5,1.3),Position(3.5,2.3),"SCORE :",Red);
      
     
       ptanks.RenderRectangle(Position(22.5,0.3),Position(28.5,2.3),Red,true);
      
        //NAME OF PLAYER 2 AND SCOREBOARD
        //Rendering the rectangle
       
       ptanks.RenderRectangle(Position(22.7,0.5),Position(28.3,2.1),White,false);
          
           //writing "Player 2"
           ptanks.RenderText(Position(22.5,0.3),Position(25.5,1.3),"PLAYER 2 :",Blue);
           
           //giving the name of the player
           ptanks.RenderText(Position(23.5,0.3),Position(28.5,1.3),s2,Black);
            
           //labeling  the scoreboard
           ptanks.RenderText(Position(22.5,1.3),Position(25.5,2.3),"SCORE :",Red);



      
      
       
        //POWER
        // POWER here has been used for the layman
        
        	ptanks.RenderRectangle(Position(1.0,11.2),Position(7.0,12.2),Blue,true);
        
            //rendering a rectangle where the POWER value will be given
            ptanks.RenderRectangle(Position(1.15,11.35),Position(6.85,12.05),White,false);
            
                //writing power within the rectangle    
                ptanks.RenderText(Position(1.0,11.2),Position(3.0,12.2),"POWER",Blue);  
                
               //rendering another rectangle inside the power rectangle from where the values will be taken
               ptanks.RenderRectangle(Position(2.8,11.4),Position(6.8,12.0),White,true);


    
        //ANGLE
        
        	ptanks.RenderRectangle(Position(22.0,11.2),Position(28.0,12.2),Blue,true);
        
            //rendering a rectangle for angle
            ptanks.RenderRectangle(Position(22.15,11.35),Position(27.85,12.05),White,false);
              
                //writing ANGLE within the rectangle
                ptanks.RenderText(Position(22.0,11.2),Position(24.0,12.2),"ANGLE",Blue);
                
                //rendering another rectangle inside angle rectangle
                ptanks.RenderRectangle(Position(23.8,11.4),Position(27.8,12.0),White,true);
      
      


      
        //THE FIRE RECTANGLE
        
        	ptanks.RenderRectangle(Position(13.0,11.4),Position(16.0,12.4),Red,true);
        
            //rendering the fire rectangle
            ptanks.RenderRectangle(Position(13.3,11.7),Position(15.7,12.1),White,false);
            
                //writing FIRE in the rectangle
                ptanks.RenderText(Position(13.0,11.4),Position(16.0,12.4),"FIRE",Red);     
      
     
        //THE WEAPON DEPOT
    
    		ptanks.RenderRectangle(Position(0.5,13.0),Position(14.0,14.0),Yellow,true);
    
            //defining the rectangle for weapon depot of player 1    
            ptanks.RenderRectangle(Position(0.65,13.15),Position(13.85,13.85),White,false);
    
                ptanks.RenderText(Position(-1.0,13.0),Position(7.0,14.0),"WEAPON",Red);
                
                //writing the player's name in weapon depot
                ptanks.RenderText(Position(-1.0,13.0),Position(4.0,14.0),s1,Blue);
                //This part
                ptanks.RenderRectangle(Position(15.0,13.0),Position(28.5,14.0),Yellow,true);
    
            //defining the rectangle of weapon depot of player 2
            ptanks.RenderRectangle(Position(15.15,13.15),Position(28.35,13.85),White,false);
    
                ptanks.RenderText(Position(13.5,13.0),Position(21.5,14.0),"WEAPON",Red);
            
                //writing the player's name in weapon depot
                ptanks.RenderText(Position(13.5,13.0),Position(18.5,14.0),s2,Blue);
    
    
    
    
    
  /* The mouse interface that will call back the function mc whenever the mouse is clicked inside the 
       and everything after the mouse click goes on in that function */
       
      ptanks.SetMouseClickCallback(mouse_click);ptanks.RenderRectangle(Position(2.8,11.4),Position(6.8,12.0),White,true);
      
  
    
        
  return 0;}
  
  /*
  The above given program just displays the screen and takes the power and angle values using mouse interface.
  Plannings:
  To send the values to projectile function and display the projectile when clicked on FIRE.
  To display the bitmap of tank layer by layer to avoid the rectangular image of tank and take it as it is.
  */
