
// Macros for "ABOUT THE GAME" window

#define WindowHeight 15.0				// Height and the Width of the window can be changed here.

#define WindowWidth 30.0				// However Height has to be a minimum of 9 and width a minimum of 16.
							 			// Note that when you increase the width, 
							 			// the alignment of the text may get affected. 
							 			// You have to set that right in case you do so.
											
#define BackButtonTop_Game 12.5     // Coordinates of the Back Buttton

#define BackButtonBottom_Game 13.5	// Coordinates of the Back Buttton

#define BackButtonLeft_Game 0.5		// Coordinates of the Back Buttton

#define BackButtonRight_Game 3.5	// Coordinates of the Back Buttton

			


SimpleWindow about("ABOUT THE GAME - POCKET TANKS",WindowWidth,WindowHeight,Position(0.0,0.0));
									// About the main game window


int OnMouseClick_Game(const Position &p)	//This function is called when mouse iS clicked on "ABOUT THE GAME" page
{
	// Checking if back button is clicked
	
	if((p.GetXDistance()<=BackButtonRight_Game)&&(p.GetXDistance()>=BackButtonLeft_Game))
    {
        if((p.GetYDistance()>=BackButtonTop_Game)&&(p.GetYDistance()<=BackButtonBottom_Game))	
           {
           
							/*
            -----------------------DEBUGGING CODE-------------------------------------
						----------------Uncomment the following lines for debugging---------------
                
						about.RenderText(Position(BackButtonLeft+5,BackButtonTop),Position(BackButtonRight+5,BackButtonBottom),"GoingBack...",Red,Black);
						*/
						
        		about.Close();		// If yes close the "ABOUT THE GAME" window 
				ApiMain();	 		// And open the main window
				return 1;               
           }
    }
    else return 0;

/*
            -----------------------DEBUGGING CODE-------------------------------------
						----------------Uncomment the following lines for debugging---------------
                
						about.RenderText(p,p,"Here",Red,Black);
*/			
			//These lines could be used to display where mouse is clicked
        
}


void about_the_game()	
{
		   
	about.Open();									// Opening the "ABOUT THE GAME" window
	assert(about.GetStatus() == WindowOpen);		// Asserting whether the window is open


	RectangleShape BackGround(about,Position(0.0,0.0),Black,WindowWidth*2,WindowHeight*2);     
	BackGround.Draw();
	// Setting the BackGround


	float CenterWidth = about.GetWidth()/2;
	Position Center = Position(about.GetXPosition()+CenterWidth,about.GetYPosition());                                  	// Getting the Screen center for diplaying the title of the Window
	

	about.RenderText(Center+Position(-3,0),Center+Position(3,3),"ABOUT THE GAME",Green,Black);	// Window Title

	float YBox=3.5;

	/*

	License Display:
	Had to do it this way because the new line character and the tab character weren't working in this RenderText()

	*/
	
	
	// Displaying text within a bounding box
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-3.5,YBox+=0.5),"This game is released under GNU GPL licence. You are free to redistribute/modify it under",White,Black);
	
	
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-2.4,YBox+=0.5),"the terms of the GNU Lesser General Public License either version 2.1",White,Black);
	
	
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-3,YBox+=0.5)," of the License, or (at your option) any later version.",White,Black);
	
	
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-1.8,YBox+=0.5),"The game is released in the hope that it will be fun and entertaining to play, however it is released",White,Black);
	
	
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-0.3,YBox+=0.5),"WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.",White,Black);
	
	
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-2.5,YBox+=0.5),"See the GNU Lesser General Public License for more details.",White,Black);
	

	/*
	
	Credits:
	Displaying the Credits...The same way

	*/

	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-0.6,YBox+=1),"This game was developed by the following students as part of the Computer Programming and Utilization course :",Blue,Black);
	
	
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-0.7,YBox+=0.5),"Anirudh D    Ankush Das    Ashwin Paranjape    Attanti Manideep    Kalla Sampath Sagar    Nikam Rohit Manikrao",White,Black);
	
	
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-0.7,YBox+=0.5),"Nivvedan S    Pravesh Agrawal    Rishikesh Awale    Sachin R    Sanket Garg    Shrikant Shalik Pardhi       ",White,Black);
	
	
	about.RenderText(about.GetPosition()+Position(0.5,YBox),about.GetPosition()+Position(about.GetWidth()-5,YBox+=0.5),"      Venkatesh Amgoth",White,Black);
	
	
	/*
	
	The "BACK" Button

	*/

	about.RenderRectangle(Position(BackButtonLeft_Game,BackButtonTop_Game),Position(BackButtonRight_Game,BackButtonBottom_Game),Green,true);
		
	about.RenderText(Position(BackButtonLeft_Game,BackButtonTop_Game),Position(BackButtonRight_Game,BackButtonBottom_Game),"<- GO BACK",Red,Green);


	about.SetMouseClickCallback(OnMouseClick_Game);  // The mouse click interface for going back to the main menu
	
}


